import bpy, addon_utils, os, ssl, json
from bpy.types import Operator
from urllib.parse import urlparse, urlencode
from urllib.request import urlopen, Request
from urllib.error import HTTPError
from ..import __package__ as base_package
class GRAPHKIT_OT_check_updates(Operator):
    bl_idname = "graphkit.check_updates"
    bl_label = "Check For Updates"
    bl_description = "Checks if there's an update for the add-on"

    #https://www.geeksforgeeks.org/compare-two-version-numbers/
    def version_compare(self, v1, v2):
        arr1 = v1.split(".")
        arr2 = v2.split(".")
        n = len(arr1)
        m = len(arr2)

        arr1 = [int(i) for i in arr1]
        arr2 = [int(i) for i in arr2]

        if n>m:
          for i in range(m, n):
             arr2.append(0)
        elif m>n:
          for i in range(n, m):
             arr1.append(0)

        for i in range(len(arr1)):
          if arr1[i]>arr2[i]:
             return 1
          elif arr2[i]>arr1[i]:
             return -1
        return 0

    def execute(self, context):
        product_id = 574
        baseurl = 'https://blastframe.com/wp-json/wc/v3/products/%s'%product_id
        consumer_key = 'ck_e89865eaa2e33ec882c9b54d485809ccf3fe769a'
        consumer_secret = 'cs_afe7d4ede8385fc304facdfdcb390ae017d1a4e9'
        url = '%s?consumer_key=%s&consumer_secret=%s'%(baseurl,consumer_key,consumer_secret)

        addon_version = [addon.bl_info.get('version', (-1,-1,-1)) for addon in addon_utils.modules() if addon.bl_info['name'] == 'GraphKit'][0]
        installed_version = ('.'.join(str(x) for x in addon_version))

        if (not os.environ.get('PYTHONHTTPSVERIFY', '') and getattr(ssl, '_create_unverified_context', None)):
            ssl._create_default_https_context = ssl._create_unverified_context

        req = Request(url, headers={'User-Agent': 'Mozilla/5.0'})
        data_string = None
        try:
            data_string = urlopen(req).read()
        except Exception:
            traceback.print_exc()
            return False

        data = json.loads(data_string)

        props = bpy.context.preferences.addons[base_package].preferences
        for item in data["meta_data"]:
            if item['key'] == "blastframe_plugin_version":
                latest_version = item['value']
                version = self.version_compare(installed_version, latest_version)
                print("installed_version: %s\nlatest_version: %s\nversion: %s"%(installed_version, latest_version, version))
                if version < 0:
                    props.update = True
                else:
                    props.update = False
                props.version = latest_version
                break
        return {'FINISHED'}

def register():
    bpy.utils.register_class(GRAPHKIT_OT_check_updates)

def unregister():
    bpy.utils.unregister_class(GRAPHKIT_OT_check_updates)
